  Program

! constants for system
ERROR_INSUFFICIENT_BUFFER        Equate(122)

! constants for printer object types
PRINTER_ENUM_DEFAULT             Equate(001h) !       1b   1d
PRINTER_ENUM_LOCAL               Equate(002h) !      10b   2d
PRINTER_ENUM_CONNECTIONS         Equate(004h) !     100b   4d
PRINTER_ENUM_FAVORITE            Equate(004h) !     100b   8d
PRINTER_ENUM_NAME                Equate(008h) !    1000b   8d
PRINTER_ENUM_REMOTE              Equate(010h) !   10000b  16d
PRINTER_ENUM_SHARED              Equate(020h) !  100000b  32d
PRINTER_ENUM_NETWORK             Equate(040h) ! 1000000b  64d

! constants for DEVMODE structure
CCHDEVICENAME                    Equate(32)
CCHFORMNAME                      Equate(32)

! constants for PRINTER_DEFAULTS structure
PRINTER_ACCESS_ADMINISTER        Equate(04h)
PRINTER_ACCESS_USE               Equate(08h)
PRINTER_ALL_ACCESS               Equate(0F000Ch)

! constants for JOB_INFO structure
MIN_PRIORITY                     Equate(1)     ! Minimum priority.
MAX_PRIORITY                     Equate(99)    ! Maximum priority.
!DEF_PRIORITY                                 ! Default priority. (in range 1:99)

! constants for printer status
PRINTER_STATUS_READY             Equate(0000000h) !                         0b         0d
PRINTER_STATUS_PAUSED            Equate(0000001h) !                         1b         1d
PRINTER_STATUS_ERROR             Equate(0000002h) !                        10b         2d
PRINTER_STATUS_PENDING_DELETION  Equate(0000004h) !                       100b         4d
PRINTER_STATUS_PAPER_JAM         Equate(0000008h) !                      1000b         8d
PRINTER_STATUS_PAPER_OUT         Equate(0000010h) !                     10000b        16d
PRINTER_STATUS_MANUAL_FEED       Equate(0000020h) !                    100000b        32d
PRINTER_STATUS_PAPER_PROBLEM     Equate(0000040h) !                   1000000b        64d
PRINTER_STATUS_OFFLINE           Equate(0000080h) !                  10000000b       128d
PRINTER_STATUS_IO_ACTIVE         Equate(0000100h) !                 100000000b       256d
PRINTER_STATUS_BUSY              Equate(0000200h) !                1000000000b       512d
PRINTER_STATUS_PRINTING          Equate(0000400h) !               10000000000b      1024d
PRINTER_STATUS_OUTPUT_BIN_FULL   Equate(0000800h) !              100000000000b      2048d
PRINTER_STATUS_NOT_AVAILABLE     Equate(0001000h) !             1000000000000b      4096d
PRINTER_STATUS_WAITING           Equate(0002000h) !            10000000000000b      8192d
PRINTER_STATUS_PROCESSING        Equate(0004000h) !           100000000000000b     16384d
PRINTER_STATUS_INITIALIZING      Equate(0008000h) !          1000000000000000b     32768d
PRINTER_STATUS_WARMING_UP        Equate(0010000h) !         10000000000000000b     65536d
PRINTER_STATUS_TONER_LOW         Equate(0020000h) !        100000000000000000b    131072d
PRINTER_STATUS_NO_TONER          Equate(0040000h) !       1000000000000000000b    262144d
PRINTER_STATUS_PAGE_PUNT         Equate(0080000h) !      10000000000000000000b    524288d
PRINTER_STATUS_USER_INTERVENTION Equate(0100000h) !     100000000000000000000b   1048576d
PRINTER_STATUS_OUT_OF_MEMORY     Equate(0200000h) !    1000000000000000000000b   2097152d
PRINTER_STATUS_DOOR_OPEN         Equate(0400000h) !   10000000000000000000000b   4194304d
PRINTER_STATUS_SERVER_UNKNOWN    Equate(0800000h) !  100000000000000000000000b   8388608d
PRINTER_STATUS_POWER_SAVE        Equate(1000000h) ! 1000000000000000000000000b  16777216d

! constants for job status
JOB_STATUS_PAUSED                Equate(0001h) !            1b     1d
JOB_STATUS_ERROR                 Equate(0002h) !           10b     2d
JOB_STATUS_DELETING              Equate(0004h) !          100b     4d
JOB_STATUS_SPOOLING              Equate(0008h) !         1000b     8d
JOB_STATUS_PRINTING              Equate(0010h) !        10000b    16d
JOB_STATUS_OFFLINE               Equate(0020h) !       100000b    32d
JOB_STATUS_PAPEROUT              Equate(0040h) !      1000000b    64d
JOB_STATUS_PRINTED               Equate(0080h) !     10000000b   128d
JOB_STATUS_DELETED               Equate(0100h) !    100000000b   256d
JOB_STATUS_BLOCKED_DEVQ          Equate(0200h) !   1000000000b   512d
JOB_STATUS_USER_INTERVENTION     Equate(0400h) !  10000000000b  1024d
JOB_STATUS_RESTART               Equate(0800h) ! 100000000000b  2048d

! System structures
_SYSTEMTIME                      Group, Type
wYear                              UShort !  WORD
wMonth                             UShort !  WORD
wDayOfWeek                         UShort !  WORD
wDay                               UShort !  WORD
wHour                              UShort !  WORD
wMinute                            UShort !  WORD
wSecond                            UShort !  WORD
wMilliseconds                      UShort !  WORD
                                 End

_PRINTER_DEFAULTS                Group, Type
pDatatype                          ULong  ! LPTSTR
pDevMode                           ULong  ! LPDEVMODE
DesiredAccess                      ULong  ! ACCESS_MASK: DWORD
                                 End

_DEVMODE                         Group, Type
dmDeviceName                       CString(32) ! cchDeviceName
dmSpecVersion                      UShort
dmDriverVersion                    UShort
dmSize                             UShort
dmDriverExtra                      UShort
dmFields                           ULong
dmOrientation                      Short
dmPaperSize                        Short
dmPaperLength                      Short
dmPaperWidth                       Short
dmScale                            Short
dmCopies                           Short
dmDefaultSource                    Short
dmPrintQuality                     Short
dmColor                            Short
dmDuplex                           Short
dmYResolution                      Short
dmTTOption                         Short
dmCollate                          Short
dmFormName                         CString(32) ! cchFormName
dmLogPixels                        UShort
dmBitsPerPel                       ULong
dmPelsWidth                        ULong
dmPelsHeight                       ULong
dmNUP                              ULong
dmDisplayFrequency                 ULong
dmICMMethod                        ULong
dmICMIntent                        ULong
dmMediaType                        ULong
dmDitherType                       ULong
dmReserved1                        ULong
dmReserved2                        ULong
                                 End

_PRINTER_INFO_2                  Group, Type
pServerName                        ULong ! LPTSTR
pPrinterName                       ULong ! LPTSTR
pShareName                         ULong ! LPTSTR
pPortName                          ULong ! LPTSTR
pDriverName                        ULong ! LPTSTR
pComment                           ULong ! LPTSTR
pLocation                          ULong ! LPTSTR
pDevMode                           ULong ! LPDEVMODE
pSepFile                           ULong ! LPTSTR
pPrintProcessor                    ULong ! LPTSTR
pDatatype                          ULong ! LPTSTR
pParameters                        ULong ! LPTSTR
pSecurityDescriptor                ULong ! PSECURITY_DESCRIPTOR
Attributes                         ULong ! DWORD
Priority                           ULong ! DWORD
DefaultPriority                    ULong ! DWORD
StartTime                          ULong ! DWORD
UntilTime                          ULong ! DWORD
Status                             ULong ! DWORD
cJobs                              ULong ! DWORD
AveragePPM                         ULong ! DWORD
                                 End

_PRINTER_INFO_4                  Group, Type
pPrinterName                       ULong ! LPTSTR
pServerName                        ULong ! LPTSTR  
Attributes                         ULong ! DWORD
                                 End

_JOB_INFO_2                      Group,Type
JobId                              ULong ! DWORD
pPrinterName                       ULong ! LPTSTR
pMachineName                       ULong ! LPTSTR
pUserName                          ULong ! LPTSTR
pDocument                          ULong ! LPTSTR
pNotifyName                        ULong ! LPTSTR
pDatatype                          ULong ! LPTSTR
pPrintProcessor                    ULong ! LPTSTR
pParameters                        ULong ! LPTSTR
pDriverName                        ULong ! LPTSTR
pDevMode                           ULong ! LPDEVMODE
pStatus                            ULong ! LPTSTR
pSecurityDescriptor                ULong ! PSECURITY_DESCRIPTOR
Status                             ULong ! DWORD
Priority                           ULong ! DWORD
Position                           ULong ! DWORD
StartTime                          ULong ! DWORD
UntilTime                          ULong ! DWORD
TotalPages                         ULong ! DWORD
Size                               ULong ! DWORD
Submitted                          Like(_SYSTEMTIME) ! SYSTEMTIME
Time                               ULong ! DWORD
PagesPrinted                       ULong ! DWORD
                                 End

  Map
    Module('WINAPI')
      OpenPrinter(<*CString pPrinterName>, *UnSigned phPrinter, <*Group pDefault>),Bool,Pascal,Raw,Name('OpenPrinterA'),Proc
      ! [in/null]   printer or server name
      ! [out]       printer or server handle
      ! [in/null]   printer defaults

      GetPrinter(UnSigned hPrinter, ULong Level, <*String pPrinter>, ULong cbBuf, *ULong pcbNeeded),Bool,Pascal,Raw,Name('GetPrinterA'),Proc
      ! [in]        handle to printer
      ! [in]        information level
      ! [out]       printer information buffer
      ! [in]        size of buffer
      ! [out]       bytes received or required

      ClosePrinter(UnSigned hPrinter),Bool,Pascal
      ! [in]        handle to printer object

      EnumPrinters(ULong Flags,<*CString pPrinterName>,ULong Level,<*String pPrinterEnum>,ULong cbBuf,*ULong pcbNeeded,*ULong pcReturned),Bool,Pascal,Raw,Name('EnumPrintersA'),Proc
      ! [in]        printer object types
      ! [in/null]   name of printer object
      ! [in]        information level [1,2,4(nt),5]
      ! [out]       printer information buffer
      ! [in]        size of printer information buffer
      ! [out]       bytes received (success) or required (buff is too small)
      ! [out]       number of printers enumerated

      EnumJobs(UnSigned hPrinter, ULong FirstJob, ULong NoJobs, ULong Level,<*String pJob>,ULong cbBuf, *ULong pcbNeeded,*ULong pcReturned),Bool,Pascal,Raw,Name('EnumJobsA'),Proc
      ! [in]        handle to printer object
      ! [in]        index of first job, zero based
      ! [in]        number of jobs to enumerate
      ! [in]        information level
      ! [out]       job information buffer
      ! [in]        size of job information buffer
      ! [out]       bytes received or required
      ! [out]       number of jobs received

      GetJob(Unsigned hPrinter,ULong JobId, ULong Level,*String pJob,ULong cbBuf,*ULong pcbNeeded),Bool,Pascal,Raw,Name('GetJobA'),Proc
      ! [in]        handle to printer
      ! [in]        job identifier
      ! [in]        information level
      ! [out]       array of jobs
      ! [in]        bytes in array
      ! [out]       bytes received or required

      GetLastError(),Long,Pascal

    End

    Main()

  End

  !
  Code
    Main()
  Return


Main Procedure

PrinterName      CString(255)
hPrinter         UnSigned

pDefault         Like(_PRINTER_DEFAULTS)

PI2              &_PRINTER_INFO_2
PI2Buff          &String

JI2              &_JOB_INFO_2
JI2Buff          &String

PI4              &_PRINTER_INFO_4
PI4Buff          &String

cbNeeded         ULong
cReturned        ULong

ThisCString      &CString

i                ULong
PrinterQ         Queue
Name               String(255)
                 End

BitPos           Byte
BitVal           ULong
BitArray         ULong

MsgText          String(255)

  Code

    ! Display the local printers names
    ! Get the size of PRINTER_INFO_4 structures array
    EnumPrinters(PRINTER_ENUM_LOCAL,, 4,, 0, cbNeeded, cReturned)

    ! Create a sufficient size of buffer to get the array
    PI4Buff &= New(String(cbNeeded))

    ! Now EnumPrinters should work
    If Not EnumPrinters(PRINTER_ENUM_LOCAL,, 4, PI4Buff, Size(PI4Buff), cbNeeded, cReturned)
       Message('Local Printer Enumeration Failed !')
    End

    ! Accessing each PRINTER_INFO_4 structure
    Loop i = 1 to cReturned
      PI4 &= ( Address(PI4Buff) + (Size(_PRINTER_INFO_4)*(i - 1)) )
      ThisCString &= (PI4.pPrinterName)
      PrinterQ.Name = ThisCstring
      Add(PrinterQ)
      if i < cReturned
         MsgText = Clip(MsgText) & ThisCString & '|'
      Else
         MsgText = Clip(MsgText) & ThisCString
      End
    End

    ! We don't need the PRINTER_INFO_4 buffer anymore
    Dispose(PI4Buff)

    ! Display the list
    i =  Message('Please select one of the following printers:<13,10>' & MsgText,' Local Printers',,MsgText)
    Get(PrinterQ, i)

    Clear(MsgText)

    ! Getting a handle to the printer
    ! PrinterName = 'HP LaserJet 4'
    PrinterName = Clip(PrinterQ.Name)
    pDefault.DesiredAccess = PRINTER_ALL_ACCESS
    
    if Not OpenPrinter(PrinterName, hPrinter, pDefault)
       Message('Open ' & Clip(PrinterName) & ' Printer Failed !')
       Return
    End

    ! we got the handle
    if hPrinter
       ! Using GetPrinter to retreive the PRINTER_INFO_2 status
       ! We need the buffer size (cbNeeded): GetPrinter fails an return an error 122, but returns the size
       GetPrinter(hPrinter, 2, , 0, cbNeeded)

       ! Create a string buffer with that size
       PI2Buff &= New(String(cbNeeded))

       ! Now GetPrinter should work
       if Not GetPrinter(hPrinter, 2, PI2Buff, Size(PI2Buff), cbNeeded)
          Message('Access ' & Clip(PrinterName) & ' Printer Failed !')
       End

       ! Allocating the PRINTER_INFO_2 structure on the buffer memory space
       PI2 &= (Address(PI2Buff))

       ! Status code translation  

       If PI2.Status = 0
          MsgText = Clip(MsgText) & ' Ready <13,10>'
       Else
          BitArray = PI2.Status
          Loop BitPos = 0 to 31
             BitVal = 2^BitPos
             Case Band(BitArray, BitVal)
             Of PRINTER_STATUS_BUSY
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Busy <13,10>'
             Of PRINTER_STATUS_DOOR_OPEN
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Door Open <13,10>'
             Of PRINTER_STATUS_ERROR
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Error <13,10>'
             Of PRINTER_STATUS_INITIALIZING
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Initializing <13,10>'
             Of PRINTER_STATUS_IO_ACTIVE
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' IO Active <13,10>'
             Of PRINTER_STATUS_MANUAL_FEED
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Manual Feed <13,10>'
             Of PRINTER_STATUS_NO_TONER
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' No Toner <13,10>'
             Of PRINTER_STATUS_NOT_AVAILABLE
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Not Available <13,10>'
             Of PRINTER_STATUS_OFFLINE
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' OffLine <13,10>'
             Of PRINTER_STATUS_OUT_OF_MEMORY
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Out of memory <13,10>'
             Of PRINTER_STATUS_OUTPUT_BIN_FULL
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Output bin full <13,10>'
             Of PRINTER_STATUS_PAGE_PUNT
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Page punt <13,10>'
             Of PRINTER_STATUS_PAPER_JAM
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Paper jam <13,10>'
             Of PRINTER_STATUS_PAPER_OUT
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Paper out <13,10>'
             Of PRINTER_STATUS_PAPER_PROBLEM
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Paper problem <13,10>'
             Of PRINTER_STATUS_PAUSED
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Paused <13,10>'
             Of PRINTER_STATUS_PENDING_DELETION
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Pending deletion <13,10>'
             Of PRINTER_STATUS_PRINTING
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Printing <13,10>'
             Of PRINTER_STATUS_PROCESSING
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Processing <13,10>'
             Of PRINTER_STATUS_TONER_LOW
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Toner low <13,10>'
             Of PRINTER_STATUS_USER_INTERVENTION
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' User intervention <13,10>'
             Of PRINTER_STATUS_WAITING
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Waiting <13,10>'
             Of PRINTER_STATUS_WARMING_UP
                BitArray = BitArray - BitVal
                MsgText  = Clip(MsgText) & ' Warming up <13,10>'
             End
             If BitArray = 0 Then Break; End
          End
       End

       ! display the printer name and status from PRINTER_INFO_2 structure
       ThisCString &= (PI2.pPrinterName)
       message('Printer status = ' & PI2.Status & '<13,10>' & MsgText,ThisCString)
       Clear(MsgText)
       !

       ! At least a Printer job is needed
       if PI2.cJobs
          ! Using EnumJobs to retreive the JOB_INFO_2 status
          ! We need the buffer size (cbNeeded): GetPrinter fails an return an error 122, but returns the size
          EnumJobs(hPrinter, 0, PI2.cJobs, 2, , 0, cbNeeded, cReturned)

          ! Create a buffer string with that size
          JI2Buff &= New(String(cbNeeded))

          ! Now EnumJobs should work
          if Not EnumJobs(hPrinter, 0, PI2.cJobs, 2, JI2Buff, Size(JI2Buff), cbNeeded, cReturned)
             Message('Enumeration of ' & Clip(PrinterName) & ' Printer''s Jobs Failed !')
          End

          ! select the currently printing job from the array
          Loop i = 1 to PI2.cJobs
             JI2 &= ( Address(JI2Buff) + (Size(_JOB_INFO_2)*(i - 1)) )
             If Band(JI2.Status, JOB_STATUS_PRINTING)
                Break
             End
          End

          ThisCString &= (JI2.pStatus)

          if Clip(ThisCstring)
             message(ThisCString,PrinterName)
          Else
             MsgText = 'Job status = ' & JI2.Status & '<13,10>'
             BitArray = JI2.Status
             Loop BitPos = 0 to 31
               BitVal = 2^BitPos
               Case Band(BitArray, BitVal)
               Of JOB_STATUS_PAUSED                
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Paused <13,10>'
               Of JOB_STATUS_ERROR
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Error <13,10>'
               Of JOB_STATUS_DELETING
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Deleting <13,10>'
               Of JOB_STATUS_SPOOLING
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Spooling <13,10>'
               Of JOB_STATUS_PRINTING
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Printing <13,10>'
               Of JOB_STATUS_OFFLINE
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Offline <13,10>'
               Of JOB_STATUS_PAPEROUT
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Paper Out <13,10>'
               Of JOB_STATUS_PRINTED
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Printed <13,10>'
               Of JOB_STATUS_DELETED
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Deleted <13,10>'
               Of JOB_STATUS_BLOCKED_DEVQ
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Device Queue Blocked <13,10>'
               Of JOB_STATUS_USER_INTERVENTION
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' User Intervention <13,10>'
               Of JOB_STATUS_RESTART
                  BitArray = BitArray - BitVal
                  MsgText  = Clip(MsgText) & ' Restart <13,10>'
               End
               If BitArray = 0 Then Break; End
             End
             Message(MsgText,PrinterName)
          End

          ! Release the buffer string
          Dispose(JI2Buff)
       !
       Else
         Message('No Jobs',PrinterName)
       End

       !
       Dispose(PI2Buff)
       !

       If Not ClosePrinter(hPrinter)
          Message('Close ' & Clip(PrinterName) & ' Printer Failed !')
       End

     End

